datablock AudioProfile(RNaruto_JutsuChidoriActivateSound)
{
   filename    = "./sounds/chidori.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RNaruto_JutsuChidoriLoopSound)
{
   filename    = "./sounds/chidori_loop_quiet.wav";
   description = AudioClosestLooping3d;
   preload = true;
};

datablock AudioProfile(RNaruto_JutsuChidoriBurstSound1)
{
   filename    = "./sounds/chidori_burst1.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RNaruto_JutsuChidoriBurstSound2)
{
   filename    = "./sounds/chidori_burst2.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RNaruto_JutsuChidoriBurstSound3)
{
   filename    = "./sounds/chidori_burst3.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ParticleData(chidoriLightningParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 15;
	textureName          = "./lightning";
	spinSpeed		= 0.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 1.0 0.0";
	colors[1]     = "1.0 1.0 1.0 1.0";
	sizes[0]      = 4.5;
	sizes[1]      = 4.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(chidoriLightningEmitter)
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 15;
   ejectionVelocity = 1.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.5;
   thetaMin         = 0;
   thetaMax         = 360;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   orientParticles = true;
   overrideAdvance = false;
   particles = "chidoriLightningParticle";

   uiName = "Chidori Lightning";
};

datablock ParticleData(chidoriDrawParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 1.0 0.0";
	colors[1]     = "1.0 1.0 1.0 0.25";
	sizes[0]      = 0.5;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(chidoriDrawEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = -5.0;
   velocityVariance = 1.0;
   ejectionOffset   = 1;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "chidoriDrawParticle";

   uiName = "Chidori Draw";
};

datablock ParticleData(chidoriFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 1.0 0.0";
	colors[1]     = "1.0 1.0 1.0 0.5";
	sizes[0]      = 1.5;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(chidoriFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "chidoriFlashParticle";

   uiName = "Chidori Flash";
};
datablock ExplosionData(chidoriShakeExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 150;

   particleEmitter = "";
   particleDensity = 5;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "0.25 0.25 0.25";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 2;
   lightStartColor = "0.5 0.5 1.0";
   lightEndColor = "1 1 1";
   
   damageRadius = 1; //3
   radiusDamage = 1000;

   impulseRadius = 1; //6
   impulseForce = 4000;
};
datablock ProjectileData(chidoriShakeProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   brickExplosionRadius = 3;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 5;
   brickExplosionMaxVolume = 24;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 24;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = chidoriShakeExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 40;
   fadeDelay           = 40;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;
   explodeOnDeath = true;

   hasLight    = false;
   lightRadius = 4.0;
   lightColor  = "0 0 0.5";

   uiName = "";
};


datablock ShapeBaseImageData(chidoriImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	//shapeFile = gunImage.shapeFile;
	
	functionName = "ChidoriFire";
	
	mountPoint = 1;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = BowItem;
	ammo = " ";
	projectile = "";
	projectileType = Projectile;

	casing = "";
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1;
	stateTransitionOnTimeout[0]      = "Flash";
	stateSound[0]					= RNaruto_JutsuChidoriActivateSound;
	stateEmitter[0]					= chidoriDrawEmitter;
	stateEmitterTime[0]				= 1;
	stateEmitterNode[0]				= "muzzleNode";

	stateName[1]                     = "Flash";
	stateAllowImageChange[1]         = true;
	stateEmitter[1]					= chidoriFlashEmitter;
	stateEmitterTime[1]				= 5.5;
	stateEmitterNode[1]				= "muzzleNode";
	stateTimeoutValue[1]			= 0.1;
	stateTransitionOnTimeout[1]		= "Draw";
	stateScript[1]					= "chargeChidori";
	
	stateName[2]                     = "Draw";
	stateAllowImageChange[2]         = true;
	stateEmitter[2]					= chidoriDrawEmitter;
	stateEmitterTime[2]				= 5.5;
	stateEmitterNode[2]				= "muzzleNode";
	stateTimeoutValue[2]			= 5;
	stateTransitionOnTimeout[2]		= "Flash";

};

datablock ShapeBaseImageData(chidoriSparkImage1 : chidoriImage)
{
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1;
	stateTransitionOnTimeout[0]      = "Remove";
	stateSound[0]					= RNaruto_JutsuChidoriBurstSound1;
	stateEmitter[0]					= chidoriLightningEmitter;
	stateEmitterTime[0]				= 0.5;
	stateEmitterNode[0]				= "muzzleNode";
	
	stateName[3]					= "Remove";
	stateScript[3]					= "unMountSparkImage";
};
datablock ShapeBaseImageData(chidoriSparkImage2 : chidoriSparkImage1)
{
	stateSound[0]					= RNaruto_JutsuChidoriBurstSound2;
};
datablock ShapeBaseImageData(chidoriSparkImage3 : chidoriSparkImage1)
{
	stateSound[0]					= RNaruto_JutsuChidoriBurstSound3;
};

function chidoriImage::onMount(%this, %player, %slot)
{
	%player.playAudio(1, RNaruto_JutsuChidoriLoopSound);
	%player.chidoriEffectsLoop();
	%player.controlPlayer.jutsuActive = "Chidori";
	%player.chidoriCharged = false;
}
function chidoriImage::onUnMount(%this, %player, %slot)
{
	%player.stopAudio(1);
	cancel(%player.chidoriLoop);
	%player.controlPlayer.jutsuActive = "";
}
function chidoriImage::chargeChidori(%this, %player, %slot)
{
	%player.chidoriCharged = true;
}

function Player::jutsuPerformChidori(%player)
{
	%player.playThread(1, chidori);
	%player.mountImage(chidoriImage, 1);
	%player.sparkLoopQuota = %player.schedule(getRandom(1700, 2300), chidoriSparkLoop);
}

function Player::chidoriEffectsLoop(%player)
{
	%position = %player.getSlotTransform(2);
	%p = new Projectile()
	{
		datablock = chidoriShakeProjectile;
		initialPosition = %position;
		client = %player.controlPlayer.client;
		sourceObject = %player.controlPlayer;
	};
	%p.schedule(30, explode);
	
	cancel(%player.chidoriLoop);
	%player.chidoriLoop = %player.schedule(80, chidoriEffectsLoop);
}

function Player::chidoriSparkLoop(%player)
{
	while(%image $= %player.lastChidSparImage || %image $= "")
		%image = "chidoriSparkImage" @ getRandom(1, 3);
		
	%player.lastChidSparImage = %image;

	%player.mountImage(%image, 2);
	%player.schedule(800, unmountImage, 2);
	
	%player.chidoriCharged = true;
	
	cancel(%player.sparkLoopQuota);
	%player.sparkLoopQuota = %player.schedule(getRandom(800, 3000), chidoriSparkLoop);
}

function Player::triggerChidoriFire(%player, %hands)
{
	if(!%hands.chidoriCharged)
	{
		%player.client.centerPrint("Your Chidori hasn't fully charged!", 3);
		return;
	}

	if(vectorLen(%player.getVelocity()) < 1)
	{
		%player.client.centerPrint("You must be moving to activate Chidori!", 3);
		return;
	}
	else
	{
	
		if(%player.chidoriActive)
		{
			return;
		}
		
		%hands.playThread(1, chidoriCharge);
		%player.chidoriActive = true;
		
		%player.preChidoriSpeed = %player.getMaxForwardSpeed();
		%player.setMaxForwardSpeed(%player.preChidoriSpeed * 6);
		
		%player.preChidoriFOV = %player.getCameraFOV();
		%player.chidoriTunnelVision();
		
		%player.chidoriActiveQuota = %player.chidoriActiveLoop(%hands);
	}
}

function Player::ChidoriTunnelVision(%player)
{
	cancel(%player.quotactv);
	%toFOV = %player.preChidoriFOV / 2;

	if(%player.getCameraFOV() > %toFOV)
	{
		%player.client.setControlCameraFOV(%player.getCameraFOV() - 1);
		%player.quotactv = %player.schedule(33, ChidoriTunnelVision);
	}
}
function Player::ChidoriRestoreVision(%player)
{
	cancel(%player.quotactv);
	if(%player.getCameraFOV() < %player.client.defaultFOV)
	{
		%player.client.setControlCameraFOV(%player.getCameraFOV() + 1);
		%player.quotactv = %player.schedule(33, ChidoriRestoreVision);
	}
}

function Player::chidoriActiveLoop(%player, %hands)
{
	cancel(%player.chidoriActiveQuota);
	

	if(vectorLen(%player.getVelocity()) < 1 || %player.jutsuActive !$= "Chidori")
	{
		%player.endChidori(%hands);
		return;
	}
	else
	{
		%player.setWhiteOut(0.8);
		
		%range = 4;
		
		%start = %player.getEyePoint();
		%end = vectorAdd(%start, vectorScale(%player.getEyeVector(), 5));
		
		%raycast = containerRaycast(%start, %end, 	$TypeMasks::PlayerObjectType |
													$TypeMasks::FxBrickObjectType, %player);
		
		if(isObject(%raycast))
		{
			if(%raycast.getClassName() !$= "fxDTSBrick")
			{
				%p = new Projectile()
				{
					datablock = chidoriShakeProjectile;
					initialPosition = %raycast.getHackPosition();
					client = %player.client;
					sourceObject = %player;
				};
				%p.schedule(30, explode);
			
				%vector = vectorScale(vectorNormalize(vectorSub(%raycast.getPosition(), %player.getPosition())), 30);
				%player.setVelocity(%vector);
			
				%player.endChidori(%hands);
				return;
			}
		}

		%player.chidoriActiveQuota = %player.schedule(40, chidoriActiveLoop, %hands);
	}
}

function Player::endChidori(%player, %hands)
{
	%hands.unmountImage(1);
	%hands.unmountImage(2);
	%player.chidoriActive = false;
	%player.jutsuActive = "";
	%player.setMaxForwardSpeed(%player.preChidoriSpeed);
	%player.ChidoriRestoreVision();
	%hands.chidoriSparkLoop();
	cancel(%hands.sparkLoopQuota);
	cancel(%player.chidoriActiveQuota);
}

