datablock AudioProfile(RNaruto_JutsuFireballIgniteSound)
{
   filename    = "./sounds/fire/ignite.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RNaruto_JutsuFireballChargeSound)
{
   filename    = "./sounds/fire/draw.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RNaruto_JutsuFireballLoopSound)
{
   filename    = "./sounds/fire/fire_small_loop1.wav";
   description = AudioClosestLooping3d;
   preload = true;
};

function Player::jutsuPerformFireballTechnique(%hands)
{
	%player = %hands.controlPlayer;
	%hands.playThread(1, fireball);
	%hands.mountImage(fireballImage, 1);
}

datablock ParticleData(fireballSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -2.5;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 0.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.3 0.0 1.0";
	colors[1]     = "0.0 0.0 0.0 1.0";
	sizes[0]      = 1.0;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(fireballSmokeEmitter)
{
   ejectionPeriodMS = 50;
   periodVarianceMS = 15;
   ejectionVelocity = -3.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   orientParticles = false;
   overrideAdvance = false;
   particles = "fireballSmokeParticle";

   uiName = "Fireball Smoke";
};

datablock ParticleData(fireballDrawParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.4 0.3 0.0";
	colors[1]     = "1.0 1.0 0.0 0.5";
	sizes[0]      = 0.5;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(fireballDrawEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = -5.0;
   velocityVariance = 1.0;
   ejectionOffset   = 1;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "fireballDrawParticle";

   uiName = "Fireball Draw";
};

datablock ParticleData(fireballFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.4 0.2 0.0";
	colors[1]     = "1.0 1.0 1.0 0.5";
	sizes[0]      = 1.0;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};
datablock ParticleEmitterData(fireballFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "fireballFlashParticle";

   uiName = "Fireball Flash";
};


datablock ShapeBaseImageData(fireballImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	//shapeFile = gunImage.shapeFile;
	
	functionName = "FireballTechniqueFire";
	altFunctionName = "FireballTechniqueFlameThrower";
	
	mountPoint = 1;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = BowItem;
	ammo = " ";
	projectile = "";
	projectileType = Projectile;

	casing = "";
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1;
	stateTransitionOnTimeout[0]      = "Presound";
	stateEmitter[0]					= fireballDrawEmitter;
	stateEmitterTime[0]				= 1.5;
	stateEmitterNode[0]				= "muzzleNode";
	stateSound[0] = RNaruto_JutsuFireballChargeSound;

	stateName[3]					= "Presound";
	stateTransitionOnTimeout[3]		= "Flash";
	stateTimeoutValue[3]			= 0.0;
	stateSound[3]					= RNaruto_JutsuFireballIgniteSound;
	
	stateName[1]                     = "Flash";
	stateAllowImageChange[1]         = true;
	stateEmitter[1]					= fireballFlashEmitter;
	stateEmitterTime[1]				= 5.5;
	stateEmitterNode[1]				= "muzzleNode";
	stateTimeoutValue[1]			= 0.0;
	stateTransitionOnTimeout[1]		= "Draw";
	stateScript[1]					= "chargeFireball";
	
	stateName[2]                     = "Draw";
	stateAllowImageChange[2]         = true;
	stateEmitter[2]					= fireballSmokeEmitter;
	stateEmitterTime[2]				= 5.5;
	stateEmitterNode[2]				= "muzzleNode";
	stateTimeoutValue[2]			= 5;
	stateTransitionOnTimeout[2]		= "Flash";

};