$ActivebotWeaponSet = new SimSet();
$ActivebotWeaponEmptySet = new SimSet();

$ninjutsu_shapefile = "./handSealItem/handSeal_mp.dts";

datablock PlayerData(emptyPlayer : playerStandardArmor)
{
	shapeFile = "base/data/shapes/empty.dts";
	boundingBox = "0.01 0.01 0.01";
	crouchboundingBox = "0.01 0.01 0.01";
	isEmptyPlayer = true;
	deathSound = "";
	painSound = "";
	useCustomPainEffects = true;
	mountSound = "";
	jumpSound = "";
	uiName = "";
};

function Player::RBotWep_MountBotGun(%player, %slot, %dataBlock)
{
	if(!isObject(%player))
		return;
		
	if(isObject(%player.botWeaponEmptyPlayer[%slot]))
		%player.botWeaponEmptyPlayer[%slot].delete();
		
	%player.botWeaponEmptyPlayer[%slot] = new AIPlayer()
	{
		dataBlock = emptyPlayer;
		controlPlayer = %player;
		isBotWeapon = true;
	};
	if(isObject(%player.botWeaponEmptyPlayer[%slot]))
	{
		MissionCleanup.add(%player.botWeaponEmptyPlayer[%slot]);
		%player.botWeaponEmptyPlayer[%slot].kill();
		%player.mountObject(%player.botWeaponEmptyPlayer[%slot], %slot);
	}
	else
	{
		return;
	}
	
	if(isObject(%player.activebotWeapon[%slot]))
		%player.activebotWeapon[%slot].delete();
	
	%player.activebotWeapon[%slot] = new AIPlayer()
	{
		dataBlock = %datablock;
		controlPlayer = %player;
		controlEmpty = %player.botWeaponEmptyPlayer[%slot];
		isBotWeapon = true;
	};
	if(isObject(%player.activebotWeapon[%slot]))
	{
		MissionCleanup.add(%player.activebotWeapon[%slot]);
		%player.activebotWeapon[%slot].kill();
		%player.botWeaponEmptyPlayer[%slot].mountObject(%player.activebotWeapon[%slot], 0);
	}
	else
	{
		%player.botWeaponEmptyPlayer[%slot].delete();
		return;
	}
	
	%player.botWeaponEmptyPlayer[%slot].mountedbotWeapon = %player.activebotWeapon[%slot];
	
	$ActivebotWeaponSet.add(%player.activebotWeapon[%slot]);
	$ActivebotWeaponEmptySet.add(%player.botWeaponEmptyPlayer[%slot]);
	
	//debug
	//%player.playThread(1, ArmReadyBoth);
}
function Player::RBotWep_UnmountGun(%player, %slot)
{
	if(isObject(%player.activebotWeapon[%slot]))
		%player.activebotWeapon[%slot].delete();
	if(isObject(%player.botWeaponEmptyPlayer[%slot]))
		%player.botWeaponEmptyPlayer[%slot].delete();
}

package NinjutsuBotPackage
{
	function armor::onDisabled(%db,%pl,%bool)
	{
		if(%db.isEmptyPlayer)
			return;
			
		return parent::onDisabled(%db,%pl,%bool);
	}
	
	function Armor::onUnMount(%this, %obj, %vehicle, %node)
	{
		if(%obj.isBotWeapon)
		{
			if(isObject(%obj))
			{
				%obj.setTransform("0 0 -999");
				%obj.schedule(10, delete);
			}
		}
		
		Parent::onUnMount(%this, %obj, %vehicle, %node);
	}
};
ActivatePackage(NinjutsuBotPackage);

datablock TSShapeConstructor(NinjutsuDts)
{
	baseShape  = $ninjutsu_shapefile;
	sequence0  = "./t_root.dsq root";
	sequence1  = "./t_monkey.dsq monkey";
	sequence2  = "./t_rat.dsq rat";
};
datablock PlayerData(NinjutsuPlayer : playerStandardArmor)
{
	shapeFile = $ninjutsu_shapefile;
	boundingBox = "10 10 10";
	crouchboundingBox = "10 10 10";
	isEmptyPlayer = true;
	deathSound = "";
	painSound = "";
	useCustomPainEffects = true;
	mountSound = "";
	jumpSound = "";
	uiName = "ninjutsu h bot";
};
function Player::NinjutsuPlayer_SetColor(%player)
{
	%player.hideNode("ALL");
	
	%client = %player.controlPlayer.client;
	
	%player.controlPlayer.hideNode("rHand");
	%player.controlPlayer.hideNode("lHand");
	%player.controlPlayer.hideNode("lHook");
	%player.controlPlayer.hideNode("rHook");
	
	if(!%client.rhand)
	{
		%player.unHideNode("rhand.001");
		%player.setNodeColor("rhand.001", %client.rhandColor);
	}
	else
	{
		%player.unHideNode("rhook.001");
		%player.setNodeColor("rhook.001", %client.rhandColor);
	}
	
	if(!%client.lhand)
	{
		%player.unHideNode("lhand.001");
		%player.setNodeColor("lhand.001", %client.lhandColor);
	}
	else
	{
		%player.unHideNode("lhook.001");
		%player.setNodeColor("lhook.001", %client.lhandColor);
	}
	
	//%player.unhideNode("ALL");
	//%player.setNodeColor("ALL", "0.6 0.6 0.6 1");
}

datablock ItemData(rally_NinjutsuItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = $ninjutsu_shapefile;
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Ninjutsu";
	iconName = "./icon_rally_Ninjutsu";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1.000";

	 // Dynamic properties defined by the scripts
	image = rally_NinjutsuImage;
	canDrop = true;
};
datablock ShapeBaseImageData(rally_NinjutsuImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = false;
   className = "WeaponImage";
   projectileType = Projectile;
   melee = false;
   armReady = true;
   doColorShift = true;
   colorShiftColor = rally_NinjutsuItem.colorShiftColor;//"0.400 0.196 0 1.000";

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]      = "TriggerUp";
	stateSound[0]					 = weaponSwitchSound;

	stateName[1]                     = "TriggerUp";
	stateTransitionOnTimeout[1]		= "Ready";
	stateTimeoutValue[1]			= 0.125;
	stateScript[1]					 = "onTriggerUp";
	stateAllowImageChange[1]         = true;

	stateName[2]                     = "TriggerDown";
	stateTransitionOnTriggerUp[2]    = "TriggerUp";
	stateScript[2]					 = "onTriggerDown";
	stateAllowImageChange[2]         = true;
	
	stateName[4]					= "Ready";
	stateTransitionOnTriggerDown[4]	= "TriggerDown";
};

function rally_NinjutsuImage::onTriggerDown(%this, %player, %slot)
{
	%eval = %player @ ".trigger" @ %player.activebotWeapon2.getMountedImage(1).functionName @ "(" @ %player.activebotWeapon2 @ ");";
	eval(%eval);
}

function rally_NinjutsuImage::onMount(%this, %player, %slot)
{
	%player.RBotWep_MountBotGun(2, NinjutsuPlayer);
	%player.activebotWeapon[2].schedule(0, NinjutsuPlayer_SetColor);
}
function rally_NinjutsuImage::onUnMount(%this, %player, %slot)
{
	%player.RBotWep_UnmountGun(2);
	%player.jutsuDecay();
	%player.jutsuActive = "";
	
	if(isObject(%player.client))
		%player.client.applyBodyParts();
}

